;*******************(C) COPYRIGHT 2019 GRAND-LOTUS *********************************
;* File Name          : EEPROM_Write_Read.INC
;* Author             : GRAND LOTUS
;* Version            : V1.00
;* Date               : 2019/07/01
;***********************************************************************************
;***********************************************************************************
;
;EEPROM写读程序
;
;***********************************************************************************
EEPROM_Write_Read:                 
	CALL        Interrupt_INIT          ;//在读写EEPROM时需关闭所有中断
;=================================================================================== 	
;//EEPROM写操作
;=================================================================================== 
EEPROM_Write:
	MOVIA		0x08
	MOVAR		FSR1
	MOVIA		0x00
	MOVAR		FSR0
;//EEPROM循环写入	
EEPROM_Write_Lp:		
    CALL        EEPROM_Write_Byte       ;//写EE
	INCR		FSR0,R
	JBTS0       FSR0,7                 
	GOTO        EEPROM_Read
	JBTS1		bWERR                   ;//判断写入是否失败
	GOTO		EEPROM_Write_Lp	
;//EEPROM写入失败
EEPROM_Write_Err:	
	NOP
	RETURN	
;===================================================================================
;//EEPROM读操作
;=================================================================================== 
EEPROM_Read:
	MOVIA		0x08
	MOVAR		FSR1
	MOVIA		0x00
	MOVAR		FSR0
;//EEPROM循环读
EEPROM_Read_Lp:		
    CALL        EEPROM_Read_Byte	    ;//读EE
	JCMPAI      0x55                    ;//校验00、55、AA、FF是否读写成功
	GOTO        EEPROM_Read_Check_Err
	INCR		FSR0,R	
	JBTS0       FSR0,7
	GOTO        EEPROM_Read_End
	JBTS0       bWERR
	GOTO        EEPROM_Read_Err
	GOTO		EEPROM_Read_Lp
;//EEPROM读失败
EEPROM_Read_Err:
    NOP
	RETURN
	
;//EEPROM读校验失败
EEPROM_Read_Check_Err:
    NOP
;//EEPROM读写结束
EEPROM_Read_End:	
	RETURN
	
;===================================================================================
;//EEPROM写入字节
;=================================================================================== 
EEPROM_Write_Byte:
	MOVIA       0x55                  ;//写00、55、AA、FF
	BSET		bEEMOD                ;//读写EE/MTP时需置位
	BSET		bEEWEN                ;//使能EE/MTP写入
	BSET		bEELOCK3              ;//EE/MTP写入解锁流程1
	BSET		bEELOCK2              ;//EE/MTP写入解锁流程2
	BSET		bEELOCK1              ;//EE/MTP写入解锁流程3
	BSET		bEEWR                 ;//写入
	NOP                               ;//CPU暂停，等待EE写入结束
	BCLR		bEEMOD                ;//写完EE，清除该位	
	RETURN

;===================================================================================
;//EEPROM读字节
;=================================================================================== 
EEPROM_Read_Byte:
	BSET		bEEMOD                ;//读EE，需置位
	RDT                               ;//读取EE
	BCLR		bEEMOD                ;//清除该位	
    RETURN	

;===================================================================================
;//中断初始化
;=================================================================================== 
Interrupt_INIT: 
    MOVIA       0x00              
	MOVAR       INTCR0
	MOVAR       INTF0
	MOVAR       INTCR1
	MOVAR       INTF1
	BCLR        OPTION,GIE            		 ;//1:总中断使能,0:屏蔽所有中断
	RETURN
	
;*********************************END OF FILE*************************************** 

