/*******************(C) COPYRIGHT 2019 GRAND-LOTUS *****************************
;* File Name          : EEPROM_WRITE_READ.C
;* Author             : GRAND LOTUS
;* Version            : V1.00
;* Date               : 2019/07/01
;*******************************************************************************
;*******************************************************************************
;
;EEPROM写读程序
;
;*******************************************************************************/
#include "common.h"
//===============================================================================
//EEPROM写操作
//===============================================================================
void EEPROM_Write_Read(void)
{   
	Interrupt_INIT();                     //在读写EEPROM时需关闭所有中断
	FSR1 = 0x08;
	FSR0 = 0x00;
	for(FSR0 = 0;FSR0 < 255;FSR0++)       //循环写
	{
	   EEPROM_Write_Byte();
	   if(EECON1 == 1)                    //判断写字节是否失败
	   {
		  __NOP();                        //写失败
	   }	
	}
	EEPROM_Read();
	
}

//===============================================================================
//EEPROM读操作
//===============================================================================
void EEPROM_Read(void)
{   
	FSR1 = 0x08;
	FSR0 = 0x00;
	for(FSR0 = 0;FSR0<255;FSR0++)         //循环读
	{
		EEPROM_Read_Byte();
		__asm;                            
	    JCMPAI      0xAA                  //校验00、55、AA、FF
		NOP
        __endasm;
		if(EECON1 == 1)                   //校验00、55、AA、FF是否读写成功
		{
			__NOP();                      //读失败 
		}		
	}
	
}
//===============================================================================
//EEPROM写入字节
//=============================================================================== 
void EEPROM_Write_Byte(void)
{   
	__asm;                                //给累加器ACC赋值调用汇编
	MOVIA      	0xAA
    __endasm;
	
    EEMOD = 1;                            //读写EE/MTP时需置位
    EEWEN = 1;                            //使能EE/MTP写入
    EELOCK3 = 1;                          //EE/MTP写入解锁流程1
    EELOCK2 = 1;                          //EE/MTP写入解锁流程2
    EELOCK1 = 1;                          //EE/MTP写入解锁流程3
    EEWE = 1;       	                  //写入
    __NOP();                              //CPU暂停，等待EE写入结束
    EEMOD = 0;      	                  //写完EE，清除该位
} 

//================================================================================
//EEPROM读字节
//================================================================================
void EEPROM_Read_Byte(void)
{   
	EEMOD = 1;                            //读EE，需置位
	__asm;                                //查表调用汇编
	RDT                                   //读取EE
    __endasm;
	EEMOD = 0;      	                  //写完EE，清除该位
	
}
//================================================================================
//中断初始化
//================================================================================
 void Interrupt_INIT(void)
{
	INTCR0 = 0;
    INTF0 = 0;
	INTCR1 = 0;
	INTF1 = 0;
    OPTION = 0;
}

/*********************************END OF FILE************************************/  
